#include <m8c.h>
#include "globdefs.h"
#include "batcheck.h"
#include "limits.h"


#define BAT_CHECK_THRESHOLD 0
#define POINTS_TO_ACCUMULATE 16

#define SINT1_INIT LONG_MAX/4
#define SINT2_INIT (SINT1_INIT + 2*BAT_CHECK_THRESHOLD)

static LONG tint1 = 0, tint2 = 0;
static BYTE tchin = 0;

void charge_completion_reset(void)
{
  tchin = 0;
  tint1 = SINT1_INIT;
  tint2 = SINT2_INIT;
}

BOOL charge_completion_check(INT value)
{
  BOOL temp;
 
  if (tchin)
  {
    tint1 += value;
    tchin--;
    return FALSE;
  }
    else
  {
    tchin = POINTS_TO_ACCUMULATE;
 
    temp = ((tint1 - tint2) < BAT_CHECK_THRESHOLD)?(TRUE):(FALSE);
               
    tint2 = tint1;
    tint1 = 0;
    
    return temp;
  }  

}