	.module batcheck.c
	.area data(ram, con, rel)
_tint1:
	.blkb 4
	.area idata
	.word 0,0
	.area data(ram, con, rel)
	.dbfile ./batcheck.c
	.dbsym s tint1 _tint1 L
_tint2:
	.blkb 4
	.area idata
	.word 0,0
	.area data(ram, con, rel)
	.dbfile ./batcheck.c
	.dbsym s tint2 _tint2 L
_tchin:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./batcheck.c
	.dbsym s tchin _tchin c
	.area text(rom, con, rel)
	.dbfile ./batcheck.c
	.dbfunc e charge_completion_reset _charge_completion_reset fV
_charge_completion_reset::
	.dbline -1
	.dbline 17
; #include <m8c.h>
; #include "globdefs.h"
; #include "batcheck.h"
; #include "limits.h"
; 
; 
; #define BAT_CHECK_THRESHOLD 0
; #define POINTS_TO_ACCUMULATE 16
; 
; #define SINT1_INIT LONG_MAX/4
; #define SINT2_INIT (SINT1_INIT + 2*BAT_CHECK_THRESHOLD)
; 
; static LONG tint1 = 0, tint2 = 0;
; static BYTE tchin = 0;
; 
; void charge_completion_reset(void)
; {
	.dbline 18
;   tchin = 0;
	mov [_tchin],0
	.dbline 19
;   tint1 = SINT1_INIT;
	mov [_tint1],31
	mov [_tint1+1],-1
	mov [_tint1+2],-1
	mov [_tint1+3],-1
	.dbline 20
;   tint2 = SINT2_INIT;
	mov [_tint2],31
	mov [_tint2+1],-1
	mov [_tint2+2],-1
	mov [_tint2+3],-1
	.dbline -2
	.dbline 21
; }
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e charge_completion_check _charge_completion_check fc
;           temp -> X+0
;          value -> X-5
_charge_completion_check::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 24
; 
; BOOL charge_completion_check(INT value)
; {
	.dbline 27
;   BOOL temp;
;  
;   if (tchin)
	cmp [_tchin],0
	jz L6
	.dbline 28
;   {
	.dbline 29
;     tint1 += value;
	mov A,[X-4]
	mov [__r3],A
	mov A,[X-5]
	mov [__r2],A
	tst [__r2],-128
	jz X0
	mov [__r1],-1
	mov [__r0],-1
	jmp X1
X0:
	mov [__r1],0
	mov [__r0],0
X1:
	mov A,[__r3]
	add [_tint1+3],A
	mov A,[__r2]
	adc [_tint1+2],A
	mov A,[__r1]
	adc [_tint1+1],A
	mov A,[__r0]
	adc [_tint1],A
	.dbline 30
;     tchin--;
	dec [_tchin]
	.dbline 31
;     return FALSE;
	mov A,0
	xjmp L5
L6:
	.dbline 34
;   }
;     else
;   {
	.dbline 35
;     tchin = POINTS_TO_ACCUMULATE;
	mov [_tchin],16
	.dbline 37
;  
;     temp = ((tint1 - tint2) < BAT_CHECK_THRESHOLD)?(TRUE):(FALSE);
	mov A,[_tint1+3]
	sub A,[_tint2+3]
	mov [__r3],A
	mov A,[_tint1+2]
	sbb A,[_tint2+2]
	mov [__r2],A
	mov A,[_tint1+1]
	sbb A,[_tint2+1]
	mov [__r1],A
	mov A,[_tint1]
	sbb A,[_tint2]
	mov [__r0],A
	mov A,[__r3]
	sub A,0
	mov A,[__r2]
	sbb A,0
	mov A,[__r1]
	sbb A,0
	mov A,[__r0]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jnc L9
X2:
	mov [X+2],1
	mov [X+1],0
	xjmp L10
L9:
	mov [X+2],0
	mov [X+1],0
L10:
	mov A,[X+2]
	mov [X+0],A
	.dbline 39
;                
;     tint2 = tint1;
	mov [_tint2],[_tint1]
	mov [_tint2+1],[_tint1+1]
	mov [_tint2+2],[_tint1+2]
	mov [_tint2+3],[_tint1+3]
	.dbline 40
;     tint1 = 0;
	mov [_tint1],0
	mov [_tint1+1],0
	mov [_tint1+2],0
	mov [_tint1+3],0
	.dbline 42
;     
;     return temp;
	mov A,[X+0]
	.dbline -2
L5:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l temp 0 c
	.dbsym l value -5 I
	.dbend
