//*****************************************************************************
//*****************************************************************************
//  FILENAME: LPF2.h
//   Version: 2.3, Updated on 2004/10/19 at 16:14:56
//  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
//
//  DESCRIPTION: C declarations for the LPF2 User Module.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems YYYY. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 LPF2_Start
#pragma fastcall16 LPF2_SetPower
#pragma fastcall16 LPF2_Stop
#pragma fastcall16 LPF2_SetC1
#pragma fastcall16 LPF2_SetC2
#pragma fastcall16 LPF2_SetC3
#pragma fastcall16 LPF2_SetC4
#pragma fastcall16 LPF2_SetCA
#pragma fastcall16 LPF2_SetCB
#pragma fastcall16 LPF2_SetPolarity

//-------------------------------------------------
// Prototypes of the LPF2 API.
//-------------------------------------------------

extern void LPF2_Start(BYTE bPowerSetting);
extern void LPF2_SetPower(BYTE bPowerSetting);
extern void LPF2_Stop(void);
extern void LPF2_SetC1(BYTE bCapValue);
extern void LPF2_SetC2(BYTE bCapValue);
extern void LPF2_SetC3(BYTE bCapValue);
extern void LPF2_SetC4(BYTE bCapValue);
extern void LPF2_SetCA(BYTE bCapValue);
extern void LPF2_SetCB(BYTE bCapValue);
extern void LPF2_SetPolarity(BYTE bPolaritySetting);

//-------------------------------------------------
// Defines for LPF2 API's.
//-------------------------------------------------

#define LPF2_OFF                                 (0x00)
#define LPF2_LOWPOWER                            (0x01)
#define LPF2_MEDPOWER                            (0x02)
#define LPF2_HIGHPOWER                           (0x03)

#define LPF2_FEEDBACK_16                         (0x00)
#define LPF2_FEEDBACK_32                         (0x01)

#define LPF2_POLARITY_INVERTING                  (0x00)
#define LPF2_POLARITY_NON_INVERTING              (0x01)

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------

#pragma ioport  LPF2_FLIN_CR0:  0x094                       //Analog SCA control register 0
BYTE            LPF2_FLIN_CR0;
#pragma ioport  LPF2_FLIN_CR1:  0x095                       //Analog SCA control register 1
BYTE            LPF2_FLIN_CR1;
#pragma ioport  LPF2_FLIN_CR2:  0x096                       //Analog SCA control register 2
BYTE            LPF2_FLIN_CR2;
#pragma ioport  LPF2_FLIN_CR3:  0x097                       //Analog SCA control register 3
BYTE            LPF2_FLIN_CR3;
#pragma ioport  LPF2_FLOUT_CR0: 0x090                      //Analog SCB control register 0
BYTE            LPF2_FLOUT_CR0;
#pragma ioport  LPF2_FLOUT_CR1: 0x091                      //Analog SCB control register 1
BYTE            LPF2_FLOUT_CR1;
#pragma ioport  LPF2_FLOUT_CR2: 0x092                      //Analog SCB control register 2
BYTE            LPF2_FLOUT_CR2;
#pragma ioport  LPF2_FLOUT_CR3: 0x093                      //Analog SCB control register 3
BYTE            LPF2_FLOUT_CR3;

//  LPF2 Cap naming convention per Gregorian and Temes, p293

#pragma ioport  LPF2_FILT_C1_REG:   0x094
BYTE            LPF2_FILT_C1_REG;
#pragma ioport  LPF2_FILT_C2_REG:   0x095
BYTE            LPF2_FILT_C2_REG;
#pragma ioport  LPF2_FILT_C3_REG:   0x090
BYTE            LPF2_FILT_C3_REG;
#pragma ioport  LPF2_FILT_C4_REG:   0x092
BYTE            LPF2_FILT_C4_REG;
#pragma ioport  LPF2_FILT_CA_REG:   0x094
BYTE            LPF2_FILT_CA_REG;
#pragma ioport  LPF2_FILT_CB_REG:   0x090
BYTE            LPF2_FILT_CB_REG;


// end of file LPF2.h
