;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: PWM.inc
;;   Version: 2.4, Updated on 2004/10/27 at 18:26:18
;;  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
;;
;;  DESCRIPTION: Assembler declarations for the PWM8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for PWM API's.
;--------------------------------------------------

PWM_CONTROL_REG_START_BIT:                 equ 0x01    ; Control register start bit
PWM_INT_REG:                               equ 0x0e1
PWM_INT_MASK:                              equ 0x02


;--------------------------------------------------
; Constants for PWM user defined values
;--------------------------------------------------

PWM_PERIOD:                                equ 0x19
PWM_PULSE_WIDTH:                           equ 0x06


;--------------------------------------------------
; Register Address Constants for PWM
;--------------------------------------------------

PWM_COUNTER_REG:                       equ 0x24   ; DR0 Count register
PWM_PERIOD_REG:                        equ 0x25   ; DR1 Period register
PWM_COMPARE_REG:                       equ 0x26   ; DR2 Compare register
PWM_CONTROL_REG:                       equ 0x27   ; Control register
PWM_FUNC_REG:                          equ 0x24   ; Function register
PWM_INPUT_REG:                         equ 0x25   ; Input register
PWM_OUTPUT_REG:                        equ 0x26   ; Output register


;--------------------------------------------------
; PWM Macro 'Functions'
;--------------------------------------------------

   macro PWM_Start_M
   or    reg[PWM_CONTROL_REG],  PWM_CONTROL_REG_START_BIT
   endm

   macro PWM_Stop_M
   and   reg[PWM_CONTROL_REG], ~PWM_CONTROL_REG_START_BIT
   endm

   macro PWM_EnableInt_M
   M8C_EnableIntMask PWM_INT_REG, PWM_INT_MASK
   endm

   macro PWM_DisableInt_M
   M8C_DisableIntMask PWM_INT_REG, PWM_INT_MASK
   endm


; end of file PWM.inc
