//*****************************************************************************
//*****************************************************************************
//  FILENAME: Tx232.h
//   Version: 3.3, Updated on 2004/11/04 at 11:09:04
//  Generated by PSoC Designer ver 4.2  b1013 : 02 September, 2004
//
//  DESCRIPTION: TX8 User Module C Language interface file for the
//               22/24/25/26/27xxx PSoC family of devices.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

/* Create pragmas to support proper argument and return value passing */
#pragma fastcall16  Tx232_SetTxIntMode
#pragma fastcall16  Tx232_EnableInt
#pragma fastcall16  Tx232_DisableInt
#pragma fastcall16  Tx232_Start
#pragma fastcall16  Tx232_Stop
#pragma fastcall16  Tx232_SendData
#pragma fastcall16  Tx232_bReadTxStatus

// High level TX functions
#pragma fastcall16  Tx232_PutSHexByte
#pragma fastcall16  Tx232_PutSHexInt
#pragma fastcall16  Tx232_CPutString
#pragma fastcall16  Tx232_PutString
#pragma fastcall16  Tx232_PutChar
#pragma fastcall16  Tx232_Write
#pragma fastcall16  Tx232_CWrite
#pragma fastcall16  Tx232_PutCRLF

//-------------------------------------------------
// Prototypes of the Tx232 API.
//-------------------------------------------------
extern void  Tx232_SetTxIntMode(BYTE bTxIntMode);
extern void  Tx232_EnableInt(void);
extern void  Tx232_DisableInt(void);
extern void  Tx232_Start(BYTE bParity);
extern void  Tx232_Stop(void);
extern void  Tx232_SendData(BYTE bTxData);
extern BYTE  Tx232_bReadTxStatus(void);

// High level TX functions
extern void   Tx232_CPutString(const char * szRomString);
extern void   Tx232_PutString(char * szRamString);
extern void   Tx232_PutChar(CHAR cData);
extern void   Tx232_Write(char * szRamString, BYTE bCount);
extern void   Tx232_CWrite(const char * szRomString, INT iCount);
extern void   Tx232_PutSHexByte(BYTE bValue);
extern void   Tx232_PutSHexInt(INT iValue);
extern void   Tx232_PutCRLF(void);

// Old style function name, Do Not Use.
// Will be removfr in a future release
#pragma fastcall16 bTx232_ReadTxStatus
extern BYTE bTx232_ReadTxStatus(void);

//------------------------------------
//  Transmitter Parity masks
//------------------------------------
#define  Tx232_PARITY_NONE         0x00
#define  Tx232_PARITY_EVEN         0x02
#define  Tx232_PARITY_ODD          0x06

//------------------------------------
//  Transmitter Status Register masks
//------------------------------------
#define  Tx232_TX_COMPLETE         0x20
#define  Tx232_TX_BUFFER_EMPTY     0x10

#define Tx232_INT_MODE_TX_REG_EMPTY 0x00
#define Tx232_INT_MODE_TX_COMPLETE  0x01

//------------------------------------
// Transmitter Interrupt masks
//------------------------------------
#define Tx232_INT_REG_ADDR                     ( 0x0e1 )
#define Tx232_bINT_MASK                        ( 0x08 )

// Old style defines, do not use.  These
// will be removed in a future release.
#define  TX8_PARITY_NONE         0x00
#define  TX8_PARITY_EVEN         0x02
#define  TX8_PARITY_ODD          0x06
#define  TX8_TX_COMPLETE         0x20
#define  TX8_TX_BUFFER_EMPTY     0x10



//-------------------------------------------------
// Register Addresses for Tx232
//-------------------------------------------------
#pragma ioport  Tx232_CONTROL_REG:  0x02f                  // Control register
BYTE            Tx232_CONTROL_REG;
#pragma ioport  Tx232_TX_SHIFT_REG: 0x02c                  // TX Shift Register register
BYTE            Tx232_TX_SHIFT_REG;
#pragma ioport  Tx232_TX_BUFFER_REG:    0x02d              // TX Buffer Register
BYTE            Tx232_TX_BUFFER_REG;
#pragma ioport  Tx232_FUNC_REG: 0x12c                      // Function register
BYTE            Tx232_FUNC_REG;
#pragma ioport  Tx232_INPUT_REG:    0x12d                  // Input register
BYTE            Tx232_INPUT_REG;
#pragma ioport  Tx232_OUTPUT_REG:   0x12e                  // Output register
BYTE            Tx232_OUTPUT_REG;

// end of file Tx232.h
