	.module main.c
	.area data(ram, con, rel)
_state::
	.blkb 1
	.area idata
	.byte 7
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e state _state c
_new_state::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e new_state _new_state c
_led_state:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s led_state _led_state c
_charge_complete:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s charge_complete _charge_complete c
_sleep_wakeup:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s sleep_wakeup _sleep_wakeup c
_send_debug_info:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s send_debug_info _send_debug_info X
_button_released:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s button_released _button_released X
_button_pressed:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s button_pressed _button_pressed X
_bat_temp:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s bat_temp _bat_temp I
_duty:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym s duty _duty I
_error_code::
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./main.c
	.dbsym e error_code _error_code c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e SendDebugData _SendDebugData fV
_SendDebugData::
	.dbline -1
	.dbline 52
; //----------------------------------------------------------------------------
; // C main line
; //----------------------------------------------------------------------------
; 
; #include <m8c.h>        // part specific constants and macros
; #include "PSoCAPI.h"    // PSoC API definitions for all User Modules
; #include "globdefs.h"
; #include "utils.h"
; #include "time.h"
; #include "batcheck.h"
; #include "globalparams.h"
; 
; 
; 
; BYTE state = POWER_ON, new_state = BAT_POWER;
; static BYTE led_state = LED_OFF;
; 
; static INT prs_val, act_val;
; static BOOL limit_val;
; 
; static INT vload, iload;
; static INT vload_filt;
; 
; static BYTE charge_complete = FALSE;
; 
; static BYTE sleep_wakeup = FALSE;
; static volatile BYTE send_debug_info = FALSE;
; static volatile BYTE button_released = FALSE;
; static volatile BYTE button_pressed =FALSE;
; 
; static INT bat_temp = 0;
; static INT duty = 0;
; 
; #if DEBUG
; BYTE error_code = NO_ERROR;
; #endif
; 
; 
; #define SLEEP_TIMEOUT 16
; 
; #define LPF_SHIFT 2
; 
; #define CHECK_MAIN_SUPPLY() CHECKBIT(MAINS_POWER_PORT, MAINS_POWER_BIT)
; #define REGULATOR_RESET() duty = 0;
; 
; #define SET_SUPPLY_VOLTAGE_LOW() VLT_CR &= ~0x07;
; #define SET_SUPPLY_VOLTAGE_HIGH() VLT_CR |= 0x04;
; 
; 
; #if DEBUG
; void SendDebugData(void)
; { 
	.dbline 53
;   Tx232_CWrite("S",1);
	push X
	mov A,0
	push A
	mov A,1
	push A
	mov A,>L5
	push A
	mov A,<L5
	push A
	xcall _Tx232_CWrite
	add SP,-4
	.dbline 54
;   Tx232_PutSHexByte(state);
	mov A,[_state]
	xcall _Tx232_PutSHexByte
	.dbline 55
;   Tx232_PutSHexByte(error_code);
	mov A,[_error_code]
	xcall _Tx232_PutSHexByte
	.dbline 56
;   Tx232_PutSHexInt(vload);
	mov X,[_vload]
	mov A,[_vload+1]
	xcall _Tx232_PutSHexInt
	.dbline 57
;   Tx232_PutSHexInt(iload);
	mov X,[_iload]
	mov A,[_iload+1]
	xcall _Tx232_PutSHexInt
	.dbline 58
;   Tx232_PutSHexInt(bat_temp);
	mov X,[_bat_temp]
	mov A,[_bat_temp+1]
	xcall _Tx232_PutSHexInt
	.dbline 59
;   Tx232_CWrite("P",1);
	mov A,0
	push A
	mov A,1
	push A
	mov A,>L6
	push A
	mov A,<L6
	push A
	xcall _Tx232_CWrite
	add SP,-4
	pop X
	.dbline -2
	.dbline 60
; }
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e sleep_timer_handler _sleep_timer_handler fV
_sleep_timer_handler::
	.dbline -1
	.dbline 66
; #endif
; 
; 
; #pragma interrupt_handler sleep_timer_handler;
; void sleep_timer_handler(void)
; {  
	.dbline 67
;   SETBIT(BUTTON_PORT, BUTTON_BIT);
	or REG[0x4],4
	.dbline 68
;   if (CHECKBIT(BUTTON_PORT, BUTTON_BIT)) button_released = TRUE;
	tst REG[0x4],4
	jz L8
	.dbline 68
	mov [_button_released],1
	xjmp L9
L8:
	.dbline 70
;     else 
;   {
	.dbline 71
;     if (button_released) button_pressed = TRUE;
	cmp [_button_released],0
	jz L10
	.dbline 71
	mov [_button_pressed],1
L10:
	.dbline 72
;     button_released = FALSE;
	mov [_button_released],0
	.dbline 73
;   }  
L9:
	.dbline 75
;   
;   CLEARBIT(BUTTON_PORT, BUTTON_BIT);
	and REG[0x4],-5
	.dbline 77
;    
;   if (LED_ON == led_state) CLEARBIT(LED_PORT, LED_BIT);
	cmp [_led_state],2
	jnz L12
	.dbline 77
	and REG[0x4],-17
	xjmp L13
L12:
	.dbline 78
;   else if (led_state == LED_BLINK) LED_PORT ^= BIT(LED_BIT); 
	cmp [_led_state],1
	jnz L14
	.dbline 78
	xor REG[0x4],16
	xjmp L15
L14:
	.dbline 79
;   else SETBIT(LED_PORT, LED_BIT);
	or REG[0x4],16
L15:
L13:
	.dbline 82
;   
; #if DEBUG   
;   send_debug_info = TRUE;
	mov [_send_debug_info],1
	.dbline -2
	.dbline 84
; #endif  
; }
L7:
	.dbline 0 ; func end
	reti
	.dbend
	.dbfunc e delay _delay fV
;         cycles -> X-4
_delay::
	.dbline -1
	push X
	mov X,SP
	.dbline 87
; 
; void delay(unsigned char cycles)
; {
L17:
	.dbline 88
L18:
	.dbline 88
;   while (cycles--);
	mov A,[X-4]
	mov [__r1],A
	mov [__r0],0
	sub A,1
	mov [X-4],A
	cmp [__r0],0
	jnz L17
	cmp [__r1],0
	jnz L17
X0:
	.dbline -2
	.dbline 89
; }
L16:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l cycles -4 c
	.dbend
	.dbfunc e sleep _sleep fc
;           temp -> X+0
_sleep::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 92
; 
; BOOL sleep(void)
; {
	.dbline 93
;   BOOL temp = FALSE;
	mov [X+0],0
	.dbline 95
;   
;   ABF_CR0 = 0;
	or F,0x10  ; iopage = 1
	mov REG[0x62],0
	and F,0xEF ; iopage = 0
	.dbline 96
;   ARF_CR &= ~ANALOG_POWER_MASK;  
	and REG[0x63],-8
	.dbline 98
;   
;   M8C_DisableIntMask(INT_MSK0, INT_MSK0_VC3);
	and REG[0xe0],127
	.dbline 99
;   M8C_EnableIntMask(INT_MSK0, INT_MSK0_GPIO);
	or REG[0xe0],32
	.dbline 101
;   
;   SETBIT(BUTTON_PORT, BUTTON_BIT);
	or REG[0x4],4
	.dbline 103
;    
;   OSC_CR0 |= OSC_CR0_SLEEP_1Hz;
	or F,0x10  ; iopage = 1
	or REG[0xe0],24
	and F,0xEF ; iopage = 0
	.dbline 105
;   
;   M8C_DisableGInt;
		and F, FEh

	.dbline 107
;   
;   M8C_ClearWDTAndSleep;
	mov REG[0xe3],56
	.dbline 108
;   INT_VC = 0;
	mov REG[0xe2],0
	.dbline 110
;   
;   M8C_Sleep;
	or REG[0xff],8
	.dbline 112
;   
;   if(CHECKBIT(INT_CLR0, 6)) return TRUE;
	tst REG[0xda],64
	jz L21
	.dbline 112
	mov A,1
	xjmp L20
L21:
	.dbline 114
; 
;   OSC_CR0 &= ~0x08;
	or F,0x10  ; iopage = 1
	and REG[0xe0],-9
	and F,0xEF ; iopage = 0
	.dbline 115
;   M8C_EnableIntMask(INT_MSK0, INT_MSK0_VC3);
	or REG[0xe0],-128
	.dbline 116
;   M8C_DisableIntMask(INT_MSK0, INT_MSK0_GPIO);
	and REG[0xe0],-33
L23:
	.dbline 118
L24:
	.dbline 118
;   
;   while(!CHECKBIT(INT_CLR0,6));
	tst REG[0xda],64
	jz L23
	.dbline 120
;    
;   ABF_CR0 = ANALOG_IO_CONTROL;
	or F,0x10  ; iopage = 1
	mov REG[0x62],8
	and F,0xEF ; iopage = 0
	.dbline 121
;   ARF_CR |= ANALOG_POWER;
	or REG[0x63],5
	.dbline 123
;       
;   M8C_EnableGInt;
		or  F, 01h

	.dbline 125
;     
;   return FALSE;  
	mov A,0
	.dbline -2
L20:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l temp 0 c
	.dbend
	.dbfunc e get_adc_sample _get_adc_sample fI
_get_adc_sample::
	.dbline -1
	.dbline 129
; }
; 
; INT get_adc_sample(void)
; {
	.dbline 130
;    ADCINC_GetSamples(1);
	push X
	mov A,1
	xcall _ADCINC_GetSamples
	pop X
L27:
	.dbline 131
L28:
	.dbline 131
;    while(!ADCINC_fIsDataAvailable());
	push X
	xcall _ADCINC_fIsDataAvailable
	pop X
	cmp A,0
	jz L27
	.dbline 132
;    return ADCINC_iClearFlagGetData();
	push X
	xcall _ADCINC_iClearFlagGetData
	mov [__r1],A
	mov [__r0],X
	pop X
	.dbline -2
L26:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e check_button_pressing _check_button_pressing fc
;           temp -> X+0
_check_button_pressing::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 136
; }
; 
; BYTE check_button_pressing(void)
; {
	.dbline 139
;   BYTE temp;
;   
;   temp = button_pressed;
	mov A,[_button_pressed]
	mov [X+0],A
	.dbline 140
;   button_pressed = 0; 
	mov [_button_pressed],0
	.dbline 142
;    
;   return temp;    
	mov A,[X+0]
	.dbline -2
L30:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l temp 0 c
	.dbend
	.dbfunc e measure_load_voltage _measure_load_voltage fV
;        repeats -> X+0
_measure_load_voltage::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 148
; }
; 
; 
; 
; void measure_load_voltage(void)
; {
	.dbline 149
;   BYTE repeats = 2;
	mov [X+0],2
	.dbline 151
;   
;   vload = 0;
	mov [_vload+1],0
	mov [_vload],0
	.dbline 153
;   
;   ADCINC_AtoDcr1 = 0xA0;
	mov REG[0x81],-96
	xjmp L33
L32:
	.dbline 156
	.dbline 157
	mov REG[0x60],3
	.dbline 158
	xcall _get_adc_sample
	mov A,[__r1]
	add [_vload+1],A
	mov A,[__r0]
	adc [_vload],A
	.dbline 160
	mov REG[0x60],2
	.dbline 161
	xcall _get_adc_sample
	mov A,[__r1]
	sub [_vload+1],A
	mov A,[__r0]
	sbb [_vload],A
	.dbline 162
L33:
	.dbline 155
;   
;   while (repeats--)
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	sub A,1
	mov [X+0],A
	cmp [__r0],0
	jnz L32
	cmp [__r1],0
	jnz L32
X1:
	.dbline 164
;   {
;     AMX_IN = 0x03;
;     vload += get_adc_sample();
;     
;     AMX_IN = 0x02;
;     vload -= get_adc_sample();
;   }
;    
;   vload >>= 1;  
	asr [_vload]
	rrc [_vload+1]
	.dbline 166
;   
;   vload_filt  -= (vload_filt >> LPF_SHIFT) - vload;
	mov [__r1],[_vload_filt+1]
	mov [__r0],[_vload_filt]
	asr [__r0]
	rrc [__r1]
	asr [__r0]
	rrc [__r1]
	mov A,[_vload+1]
	sub [__r1],A
	mov A,[_vload]
	sbb [__r0],A
	mov A,[__r1]
	sub [_vload_filt+1],A
	mov A,[__r0]
	sbb [_vload_filt],A
	.dbline -2
	.dbline 167
; }
L31:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l repeats 0 c
	.dbend
	.dbfunc e measure_load_current _measure_load_current fV
;        repeats -> X+0
_measure_load_current::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 170
; 
; void measure_load_current(void)
; {  
	.dbline 171
;   BYTE repeats = 2;   
	mov [X+0],2
	.dbline 172
;   iload = 0;
	mov [_iload+1],0
	mov [_iload],0
	.dbline 174
;   
;   ADCINC_AtoDcr1 = 0x60;
	mov REG[0x81],96
	xjmp L37
L36:
	.dbline 177
	.dbline 178
	mov REG[0x60],8
	.dbline 179
	mov A,2
	push A
	xcall _delay
	.dbline 180
	xcall _get_adc_sample
	mov A,[__r1]
	add [_iload+1],A
	mov A,[__r0]
	adc [_iload],A
	.dbline 182
	mov REG[0x60],12
	.dbline 183
	mov A,2
	push A
	xcall _delay
	add SP,-2
	.dbline 184
	xcall _get_adc_sample
	mov A,[__r1]
	sub [_iload+1],A
	mov A,[__r0]
	sbb [_iload],A
	.dbline 185
L37:
	.dbline 176
;   
;   while(repeats--)
	mov A,[X+0]
	mov [__r1],A
	mov [__r0],0
	sub A,1
	mov [X+0],A
	cmp [__r0],0
	jnz L36
	cmp [__r1],0
	jnz L36
X2:
	.dbline 187
;   {
;     AMX_IN = 0x08;    
;     delay(FILTER_SETUP);  
;     iload += get_adc_sample();
;   
;     AMX_IN = 0x0C;
;     delay(FILTER_SETUP);
;     iload -= get_adc_sample();
;   }  
;   
;   iload >>= 1;
	asr [_iload]
	rrc [_iload+1]
	.dbline -2
	.dbline 188
; }
L35:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l repeats 0 c
	.dbend
	.dbfunc e measure_bat_temperature _measure_bat_temperature fV
_measure_bat_temperature::
	.dbline -1
	.dbline 191
; 
; void measure_bat_temperature(void)
; {
	.dbline 192
;   AMX_IN = 0;
	mov REG[0x60],0
	.dbline 193
;   ADCINC_AtoDcr1 = 0xA0;
	mov REG[0x81],-96
	.dbline 195
;   
;   PGA_GAIN_CR2 |= 0x1C;
	or REG[0x73],28
	.dbline 196
;   bat_temp = get_adc_sample();
	xcall _get_adc_sample
	mov [_bat_temp+1],[__r1]
	mov [_bat_temp],[__r0]
	.dbline 198
;   
;   PGA_GAIN_CR2 &= ~0x08;
	and REG[0x73],-9
	.dbline 199
;   bat_temp -= get_adc_sample();  
	xcall _get_adc_sample
	mov A,[__r1]
	sub [_bat_temp+1],A
	mov A,[__r0]
	sbb [_bat_temp],A
	.dbline -2
	.dbline 200
; }
L39:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./main.c
L41:
	.blkb 1
	.area idata
	.byte 1
	.area data(ram, con, rel)
	.dbfile ./main.c
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e check_temp_range _check_temp_range fc
	.dbsym s old_st L41 c
;         new_st -> X+0
_check_temp_range::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 203
; 
; BOOL check_temp_range(void)
; { 
	.dbline 207
	mov A,-54
	sub A,[_bat_temp+1]
	mov A,[_bat_temp]
	xor A,-128
	mov [__rX],A
	mov A,(3 ^ 0x80)
	sbb A,[__rX]
	jc L44
X3:
	mov A,[_bat_temp+1]
	sub A,100
	mov A,[_bat_temp]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jnc L42
X4:
L44:
	.dbline 207
;   static BOOL old_st = TRUE;  
;   BYTE new_st;
;   
;   if ((bat_temp > TEMP_LOW_OFF) || (bat_temp < TEMP_HIGH_OFF)) new_st = FALSE;
	mov [X+0],0
	xjmp L43
L42:
	.dbline 209
;     else 
;   if ((bat_temp > TEMP_HIGH_ON) && (bat_temp < TEMP_LOW_ON)) new_st = TRUE;
	mov A,120
	sub A,[_bat_temp+1]
	mov A,[_bat_temp]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L45
X5:
	mov A,[_bat_temp+1]
	sub A,-74
	mov A,[_bat_temp]
	xor A,-128
	sbb A,(3 ^ 0x80)
	jnc L45
X6:
	.dbline 209
	mov [X+0],1
	xjmp L46
L45:
	.dbline 211
;     else
;   new_st = old_st;  
	mov A,[L41]
	mov [X+0],A
L46:
L43:
	.dbline 213
;     
;   old_st = new_st;
	mov A,[X+0]
	mov [L41],A
	.dbline 215
;   
;   return new_st;
	mov A,[X+0]
	.dbline -2
L40:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l new_st 0 c
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./main.c
L48:
	.blkb 1
L49:
	.blkb 2
L50:
	.blkb 2
	.area text(rom, con, rel)
	.dbfile ./main.c
	.dbfunc e pfm_regulate _pfm_regulate fV
	.dbsym s abs_diff L50 I
	.dbsym s diff L49 I
	.dbsym s step L48 c
_pfm_regulate::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 219
; }
; 
; void pfm_regulate(void)
; {  
	.dbline 223
;    static BYTE step;
;    static INT diff, abs_diff;
;    
;    diff = prs_val - act_val;
	mov A,[_prs_val+1]
	sub A,[_act_val+1]
	mov [L49+1],A
	mov A,[_prs_val]
	sbb A,[_act_val]
	mov [L49],A
	.dbline 224
;    abs_diff = (diff > 0)?(diff):(-diff);
	mov A,0
	sub A,[L49+1]
	mov A,[L49]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L52
X7:
	mov A,[L49+1]
	mov [X+1],A
	mov A,[L49]
	mov [X+0],A
	xjmp L53
L52:
	mov A,[L49+1]
	cpl A
	sub A,-1
	mov [X+1],A
	mov A,[L49]
	cpl A
	sbb A,-1
	mov [X+0],A
L53:
	mov A,[X+1]
	mov [L50+1],A
	mov A,[X+0]
	mov [L50],A
	.dbline 226
;    
;    if (abs_diff > DIF1) step = STEP1;
	mov A,-16
	sub A,[L50+1]
	mov A,[L50]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L54
X8:
	.dbline 226
	mov [L48],20
	xjmp L55
L54:
	.dbline 228
;      else 
;    if (abs_diff > DIF2) step = STEP2;
	mov A,50
	sub A,[L50+1]
	mov A,[L50]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L56
X9:
	.dbline 228
	mov [L48],4
	xjmp L57
L56:
	.dbline 230
;      else 
;    if (abs_diff > DIF3) step = STEP3;
	mov A,15
	sub A,[L50+1]
	mov A,[L50]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L58
X10:
	.dbline 230
	mov [L48],2
	xjmp L59
L58:
	.dbline 232
;      else
;    step = 1;
	mov [L48],1
L59:
L57:
L55:
	.dbline 235
; 
;      
;    if ((diff > DIF_DELTA) && (0 == limit_val)) duty += step;
	mov A,10
	sub A,[L49+1]
	mov A,[L49]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L60
X11:
	cmp [_limit_val],0
	jnz L60
	.dbline 235
	mov A,[L48]
	add [_duty+1],A
	adc [_duty],0
L60:
	.dbline 236
	mov A,[L49+1]
	sub A,10
	mov A,[L49]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jc L64
X12:
	cmp [_limit_val],0
	jz L62
L64:
	.dbline 236
;    if ((diff < DIF_DELTA) || (0 != limit_val)) duty -= step;
	mov A,[L48]
	sub [_duty+1],A
	sbb [_duty],0
L62:
	.dbline 238
	.dbline 238
	mov A,[_duty+1]
	sub A,0
	mov A,[_duty]
	xor A,-128
	sbb A,(0 ^ 0x80)
	jnc L65
X13:
	.dbline 238
	mov [_duty+1],0
	mov [_duty],0
L65:
	.dbline 238
	mov A,-1
	sub A,[_duty+1]
	mov A,[_duty]
	xor A,-128
	mov [__rX],A
	mov A,(0 ^ 0x80)
	sbb A,[__rX]
	jnc L67
X14:
	.dbline 238
	mov [_duty+1],-1
	mov [_duty],0
L67:
	.dbline 238
;    								 
;    CHECKRANGE(duty, DUTY_MIN, DUTY_MAX);	
	.dbline 238
	.dbline 240
;    
;    PRS8_SEED_REG = (BYTE)duty;						 
	mov [__r0],[_duty+1]
	mov A,[__r0]
	mov REG[0x2a],A
	.dbline -2
	.dbline 241
; }   
L47:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e state_machine _state_machine fV
_state_machine::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 244
; 
; void state_machine(void)
; {
	.dbline 245
;   new_state = state;
	mov [_new_state],[_state]
	.dbline 247
	tst REG[0x4],32
	jz L70
	.dbline 247
	.dbline 247
	and [_new_state],7
	.dbline 247
	or [_new_state],2
	mov A,[_new_state]
	.dbline 247
	xjmp L71
L70:
	.dbline 247
; 
;   if(CHECK_MAIN_SUPPLY()) {new_state &= 0x07; new_state |= 0x02;} else new_state &= ~0x06;  
	and [_new_state],-7
L71:
	.dbline 248
;   if (check_button_pressing()) {new_state &= 0x03; new_state ^= 0x01;}
	xcall _check_button_pressing
	cmp A,0
	jz L72
	.dbline 248
	.dbline 248
	and [_new_state],3
	.dbline 248
	xor [_new_state],1
	.dbline 248
L72:
	.dbline 250
;   
;   switch (state)
	mov A,[_state]
	mov [X+1],A
	mov [X+0],0
	cmp [X+0],0
	jnz X16
	cmp [X+1],0
	jz L77
X16:
	cmp [X+0],0
	jnz X17
	cmp [X+1],1
	jz L81
X17:
	cmp [X+0],0
	jnz X18
	cmp [X+1],2
	jz L84
X18:
	cmp [X+0],0
	jnz X19
	cmp [X+1],3
	jz L88
X19:
	cmp [X+0],0
	jnz X20
	cmp [X+1],6
	jz L92
X20:
	cmp [X+0],0
	jnz X21
	cmp [X+1],8
	jz L80
X21:
	xjmp L74
X15:
	.dbline 251
;   {
L77:
	.dbline 253
;     case BAT_POWER:
;       SET_SUPPLY_VOLTAGE_LOW();
	or F,0x10  ; iopage = 1
	and REG[0xe3],-8
	and F,0xEF ; iopage = 0
	.dbline 253
	.dbline 254
;       set_state_timer(TIME_DELAY_TO_SLEEP);            
	mov A,0
	push A
	mov A,2
	push A
	xcall _set_state_timer
	add SP,-2
	.dbline 255
;       BAT_OFF();
	and REG[0x4],-65
	.dbline 256
;       MOTOR_OFF();
	and REG[0x4],-9
	.dbline 257
;       led_state = LED_OFF;
	mov [_led_state],0
	.dbline 258
;       charge_complete = FALSE;
	mov [_charge_complete],0
	.dbline 260
; #if DEBUG      
;       error_code = NO_ERROR;
	mov [_error_code],0
	.dbline 262
; #endif      
;       PWM_Stop();
	push X
	xcall _PWM_Stop
	pop X
	.dbline 264
;       
;       if(check_state_timer()) new_state = SLEEP;          
	xcall _check_state_timer
	cmp A,0
	jz L75
	.dbline 264
	mov [_new_state],8
	.dbline 265
;     break;
	xjmp L75
L80:
	.dbline 268
;     
;     case SLEEP: 
;       SET_SUPPLY_VOLTAGE_LOW();    
	or F,0x10  ; iopage = 1
	and REG[0xe3],-8
	and F,0xEF ; iopage = 0
	.dbline 268
	.dbline 269
;       set_state_timer(0); 
	mov A,0
	push A
	push A
	xcall _set_state_timer
	add SP,-2
	.dbline 270
;     break;    
	xjmp L75
L81:
	.dbline 273
;     
;     case BAT_MOTOR:
;       SET_SUPPLY_VOLTAGE_HIGH();
	or F,0x10  ; iopage = 1
	or REG[0xe3],4
	and F,0xEF ; iopage = 0
	.dbline 273
	.dbline 274
;       set_state_timer(0); 
	mov A,0
	push A
	push A
	xcall _set_state_timer
	add SP,-2
	.dbline 275
;       BAT_ON();
	or REG[0x4],64
	.dbline 276
;       MOTOR_ON();
	or REG[0x4],8
	.dbline 277
;       led_state = LED_OFF; 
	mov [_led_state],0
	.dbline 278
;       PWM_Stop();  
	push X
	xcall _PWM_Stop
	pop X
	.dbline 280
;       
;       if (vload < BAT_VOLT_MOTOR_STOP) new_state = BAT_POWER;
	mov A,[_vload+1]
	sub A,87
	mov A,[_vload]
	xor A,-128
	sbb A,(2 ^ 0x80)
	jnc L75
X22:
	.dbline 280
	mov [_new_state],0
	.dbline 281
;     break;
	xjmp L75
L84:
	.dbline 284
;     
;     case EXT_POWER:
;       SET_SUPPLY_VOLTAGE_HIGH();  
	or F,0x10  ; iopage = 1
	or REG[0xe3],4
	and F,0xEF ; iopage = 0
	.dbline 284
	.dbline 285
;       set_state_timer(0); 
	mov A,0
	push A
	push A
	xcall _set_state_timer
	add SP,-2
	.dbline 286
;       BAT_ON();
	or REG[0x4],64
	.dbline 287
;       MOTOR_OFF();
	and REG[0x4],-9
	.dbline 288
;       led_state = LED_ON;  
	mov [_led_state],2
	.dbline 289
;       PWM_Start();
	push X
	xcall _PWM_Start
	pop X
	.dbline 291
;       
;       prs_val = SUPPLY_CURRENT;
	mov [_prs_val+1],16
	mov [_prs_val],0
	.dbline 292
;       act_val = iload; 
	mov [_act_val+1],[_iload+1]
	mov [_act_val],[_iload]
	.dbline 293
;       limit_val = FALSE; 
	mov [_limit_val],0
	.dbline 295
;                  
;       if ((FALSE == charge_complete) || (vload < BAT_VOLT_CHARGE_START)) 
	cmp [_charge_complete],0
	jz L87
	mov A,[_vload+1]
	sub A,-3
	mov A,[_vload]
	xor A,-128
	sbb A,(2 ^ 0x80)
	jnc L75
X23:
L87:
	.dbline 296
;       {
	.dbline 297
;         new_state = CHARGING;
	mov [_new_state],6
	.dbline 298
;         set_interval_timer(TIME_BAT_VOLT_AND_TEMP);
	mov A,4
	push A
	xcall _set_interval_timer
	add SP,-1
	.dbline 299
;         prs_val = BAT_CURRENT_TRICLE;
	mov [_prs_val+1],84
	mov [_prs_val],0
	.dbline 300
;         charge_completion_reset();
	xcall _charge_completion_reset
	.dbline 301
;       }           
	.dbline 302
;     break;
	xjmp L75
L88:
	.dbline 305
;     
;     case EXT_MOTOR:
;       SET_SUPPLY_VOLTAGE_HIGH();
	or F,0x10  ; iopage = 1
	or REG[0xe3],4
	and F,0xEF ; iopage = 0
	.dbline 305
	.dbline 306
;       set_state_timer(0); 
	mov A,0
	push A
	push A
	xcall _set_state_timer
	add SP,-2
	.dbline 307
;       BAT_OFF();
	and REG[0x4],-65
	.dbline 308
;       MOTOR_ON();
	or REG[0x4],8
	.dbline 309
;       led_state = LED_OFF;  
	mov [_led_state],0
	.dbline 310
;       PWM_Start();   
	push X
	xcall _PWM_Start
	pop X
	.dbline 312
;        
;       prs_val = MOTOR_VOLTAGE_EXT_POW;      
	mov [_prs_val+1],-126
	mov [_prs_val],3
	.dbline 313
;       act_val = vload;                
	mov [_act_val+1],[_vload+1]
	mov [_act_val],[_vload]
	.dbline 314
;       limit_val = (iload > MOTOR_MAX_CURRENT);
	mov A,78
	sub A,[_iload+1]
	mov A,[_iload]
	xor A,-128
	mov [__rX],A
	mov A,(3 ^ 0x80)
	sbb A,[__rX]
	jnc L90
X24:
	mov [X+3],1
	mov [X+2],0
	xjmp L91
L90:
	mov [X+3],0
	mov [X+2],0
L91:
	mov A,[X+3]
	mov [_limit_val],A
	.dbline 315
;     break;
	xjmp L75
L92:
	.dbline 318
;     
;     case CHARGING:
;       SET_SUPPLY_VOLTAGE_HIGH();
	or F,0x10  ; iopage = 1
	or REG[0xe3],4
	and F,0xEF ; iopage = 0
	.dbline 318
	.dbline 319
;       set_state_timer(TIME_TOTAL_CHARGE); 
	mov A,28
	push A
	mov A,32
	push A
	xcall _set_state_timer
	add SP,-2
	.dbline 320
;       MOTOR_OFF();
	and REG[0x4],-9
	.dbline 321
;       BAT_ON();
	or REG[0x4],64
	.dbline 322
;       PWM_Start();
	push X
	xcall _PWM_Start
	pop X
	.dbline 323
;       led_state = LED_BLINK;
	mov [_led_state],1
	.dbline 325
;       
;       act_val = iload; 
	mov [_act_val+1],[_iload+1]
	mov [_act_val],[_iload]
	.dbline 326
;       limit_val = FALSE;
	mov [_limit_val],0
	.dbline 328
;       
;       if(check_interval_timer()) 
	xcall _check_interval_timer
	cmp A,0
	jz L93
	.dbline 329
;       {
	.dbline 330
;         set_interval_timer(TIME_BAT_VOLT_AND_TEMP);
	mov A,4
	push A
	xcall _set_interval_timer
	add SP,-1
	.dbline 331
;         measure_bat_temperature();
	xcall _measure_bat_temperature
	.dbline 333
;         
;         if (check_temp_range()) 
	xcall _check_temp_range
	cmp A,0
	jz L95
	.dbline 334
;         {
	.dbline 335
;           control_state_timer(TRUE);
	mov A,1
	push A
	xcall _control_state_timer
	add SP,-1
	.dbline 336
;           prs_val = BAT_CURRENT_RAPID;
	mov [_prs_val+1],78
	mov [_prs_val],3
	.dbline 337
;         } 
	xjmp L96
L95:
	.dbline 339
;           else
;         {
	.dbline 340
;           control_state_timer(FALSE);
	mov A,0
	push A
	xcall _control_state_timer
	add SP,-1
	.dbline 341
;           prs_val = BAT_CURRENT_TRICLE;
	mov [_prs_val+1],84
	mov [_prs_val],0
	.dbline 342
;           charge_completion_reset();
	xcall _charge_completion_reset
	.dbline 343
;         }
L96:
	.dbline 345
;         
;         if(charge_completion_check(vload_filt)) 
	mov A,[_vload_filt]
	push A
	mov A,[_vload_filt+1]
	push A
	xcall _charge_completion_check
	add SP,-2
	cmp A,0
	jz L97
	.dbline 346
;           if (read_state_timer() < (TIME_TOTAL_CHARGE - TIME_STARTUP_DELAY))
	xcall _read_state_timer
	mov A,[__r1]
	sub A,-12
	mov A,[__r0]
	sbb A,26
	jnc L99
X25:
	.dbline 347
;           {
	.dbline 348
;             new_state = EXT_POWER; 
	mov [_new_state],2
	.dbline 350
; #if DEBUG            
;             error_code = CHARGE_COMPLETED_WELL;
	mov [_error_code],3
	.dbline 352
; #endif            
;             charge_complete = TRUE;
	mov [_charge_complete],1
	.dbline 353
;           } 
L99:
L97:
	.dbline 354
;       }
L93:
	.dbline 356
;       
;       if (check_state_timer())
	xcall _check_state_timer
	cmp A,0
	jz L101
	.dbline 357
;       { 
	.dbline 358
;         new_state = EXT_POWER;
	mov [_new_state],2
	.dbline 359
;         charge_complete = TRUE;
	mov [_charge_complete],1
	.dbline 361
; #if DEBUG        
;         error_code = TIMEOUT_ERROR;
	mov [_error_code],2
	.dbline 363
; #endif        
;       }  
L101:
	.dbline 365
;       
;       if (vload > BAT_VOLT_OVER)
	mov A,-82
	sub A,[_vload+1]
	mov A,[_vload]
	xor A,-128
	mov [__rX],A
	mov A,(4 ^ 0x80)
	sbb A,[__rX]
	jnc L75
X26:
	.dbline 366
;       {
	.dbline 367
;         new_state = EXT_POWER;
	mov [_new_state],2
	.dbline 368
;         charge_complete = TRUE;
	mov [_charge_complete],1
	.dbline 370
; #if DEBUG        
;         error_code = OVER_VOLT_ERROR;
	mov [_error_code],1
	.dbline 372
; #endif        
;       }
	.dbline 373
;     break;
	xjmp L75
L74:
	.dbline 376
;     
;     default:
;       new_state = BAT_POWER;
	mov [_new_state],0
	.dbline 377
;     break;  
L75:
	.dbline 380
	mov A,[_new_state]
	cmp A,[_state]
	jz L105
	.dbline 380
	mov [_duty+1],0
	mov [_duty],0
L105:
	.dbline 380
;   }
;   
;   if(new_state != state) REGULATOR_RESET(); 
	.dbline 381
;   state = new_state;
	mov [_state],[_new_state]
	.dbline -2
	.dbline 382
; }
L69:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e main _main fV
_main::
	.dbline -1
	.dbline 385
; 
; void main()
; {
	.dbline 386
;   VLT_CR &= ~0x30;
	or F,0x10  ; iopage = 1
	and REG[0xe3],-49
	and F,0xEF ; iopage = 0
	.dbline 388
;   
;   PRS8_WriteSeed(0x01);
	push X
	mov A,1
	xcall _PRS8_WriteSeed
	.dbline 389
;   PRS8_WritePolynomial(0xB8);
	mov A,-72
	xcall _PRS8_WritePolynomial
	.dbline 390
;   PRS8_Start();
	xcall _PRS8_Start
	pop X
	.dbline 391
;   PRS8_SEED_REG = 0x00;
	mov REG[0x2a],0
	.dbline 393
;   
;   M8C_EnableIntMask(INT_MSK0, INT_MSK0_SLEEP);  
	or REG[0xe0],64
	.dbline 394
;   M8C_EnableIntMask(INT_MSK0, INT_MSK0_VC3);
	or REG[0xe0],-128
	.dbline 396
;     
;   M8C_EnableGInt;
		or  F, 01h

	.dbline 399
;   
; #if DEBUG  
;   Tx232_Start(Tx232_PARITY_NONE);
	push X
	mov A,0
	xcall _Tx232_Start
	pop X
	.dbline 400
;   SendDebugData();
	xcall _SendDebugData
	.dbline 402
; #endif  
;   state = BAT_POWER;
	mov [_state],0
	.dbline 404
;   
;   PGA_Start(PGA_MEDPOWER);
	push X
	mov A,2
	xcall _PGA_Start
	.dbline 405
;   ADCINC_Start(ADCINC_MEDPOWER);
	mov A,2
	xcall _ADCINC_Start
	.dbline 407
;   
;   LPF2_Start(LPF2_MEDPOWER);			
	mov A,2
	xcall _LPF2_Start
	pop X
	.dbline 408
;   LPF2_FLIN_CR3 |= 0x80;	
	or REG[0x97],-128
	xjmp L109
L108:
	.dbline 411
;   
;   while (1)
;   {     
	.dbline 412
;     M8C_ClearWDT;  
	mov REG[0xe3],0
	.dbline 415
;     
; #if DEBUG  
;     if (send_debug_info) 
	cmp [_send_debug_info],0
	jz L111
	.dbline 416
;     {
	.dbline 417
;       send_debug_info = FALSE;
	mov [_send_debug_info],0
	.dbline 418
;       SendDebugData();
	xcall _SendDebugData
	.dbline 419
;     }    
L111:
	.dbline 422
; #endif        
; 
;      if(SLEEP == state) if(sleep()) continue; 
	cmp [_state],8
	jnz L113
	.dbline 422
	xcall _sleep
	cmp A,0
	jz L115
	.dbline 422
	xjmp L109
L115:
L113:
	.dbline 424
	xcall _measure_load_voltage
	.dbline 425
	xcall _measure_load_current
	.dbline 426
	xcall _pfm_regulate
	.dbline 428
	xcall _state_machine
	.dbline 429
L109:
	.dbline 410
	xjmp L108
X27:
	.dbline -2
	.dbline 430
;          
;       measure_load_voltage();
;       measure_load_current();
;       pfm_regulate();          
;      
;       state_machine();
;   }
; }
L107:
	.dbline 0 ; func end
	jmp .
	.dbend
	.area bss(ram, con, rel)
	.dbfile ./main.c
_vload_filt:
	.blkb 2
	.dbsym s vload_filt _vload_filt I
_iload:
	.blkb 2
	.dbsym s iload _iload I
_vload:
	.blkb 2
	.dbsym s vload _vload I
_limit_val:
	.blkb 1
	.dbsym s limit_val _limit_val c
_act_val:
	.blkb 2
	.dbsym s act_val _act_val I
_prs_val:
	.blkb 2
	.dbsym s prs_val _prs_val I
	.area lit(rom, con, rel)
L6:
	.byte 'P,0
L5:
	.byte 'S,0
