#include <m8c.h>
#include "time.h"
#include "globdefs.h"

static volatile WORD state_timer = 0;
static volatile BYTE interval_timer = 0;
static volatile BYTE state_timer_mode = 0;

#define SB(var, num) *(((BYTE*)&var)+num)
#define WZC(var) (SB(var,0)|SB(var,1))

extern BYTE state;


#pragma interrupt_handler vc3_handler;
void vc3_handler(void)
{
  static WORD time = 0;
  
  time++;
  if (VC3_TIME_INTERVAL == time)
  {
    time = 0;
    if (WZC(state_timer) && state_timer_mode) state_timer--;
    if (interval_timer) interval_timer--;
  }
}


void set_state_timer(WORD value)
{
  static BYTE old_state = POWER_ON;
  
  if (state != old_state)
  {
    M8C_DisableGInt;
    state_timer = value;
    state_timer_mode = TRUE;
    M8C_EnableGInt;
  }
  
  old_state = state;  
}


BOOL check_state_timer(void)
{
   BOOL cond;

   M8C_DisableGInt;
   cond = WZC(state_timer);
   M8C_EnableGInt;
   
   return !cond;
}

void control_state_timer(BYTE timer_resume)
{
  state_timer_mode =  timer_resume;
}

WORD read_state_timer(void)
{
   WORD temp;
   
   M8C_DisableGInt;
   temp = state_timer;
   M8C_EnableGInt;
   
   return temp;
}

void set_interval_timer(BYTE value)
{
  interval_timer = value;
}

BYTE check_interval_timer(void)
{  
   BYTE temp = interval_timer;
   return !temp;
}
