	.module time.c
	.area data(ram, con, rel)
_state_timer:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile ./time.c
	.dbsym s state_timer _state_timer X
_interval_timer:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./time.c
	.dbsym s interval_timer _interval_timer X
_state_timer_mode:
	.blkb 1
	.area idata
	.byte 0
	.area data(ram, con, rel)
	.dbfile ./time.c
	.dbsym s state_timer_mode _state_timer_mode X
L5:
	.blkb 2
	.area idata
	.word 0
	.area data(ram, con, rel)
	.dbfile ./time.c
	.area text(rom, con, rel)
	.dbfile ./time.c
	.dbfunc e vc3_handler _vc3_handler fV
	.dbsym s time L5 i
_vc3_handler::
	.dbline -1
	push A
	.dbline 17
; #include <m8c.h>
; #include "time.h"
; #include "globdefs.h"
; 
; static volatile WORD state_timer = 0;
; static volatile BYTE interval_timer = 0;
; static volatile BYTE state_timer_mode = 0;
; 
; #define SB(var, num) *(((BYTE*)&var)+num)
; #define WZC(var) (SB(var,0)|SB(var,1))
; 
; extern BYTE state;
; 
; 
; #pragma interrupt_handler vc3_handler;
; void vc3_handler(void)
; {
	.dbline 20
;   static WORD time = 0;
;   
;   time++;
	inc [L5+1]
	adc [L5],0
	.dbline 21
;   if (VC3_TIME_INTERVAL == time)
	cmp [L5],2
	jnz L6
	cmp [L5+1],88
	jnz L6
X0:
	.dbline 22
;   {
	.dbline 23
;     time = 0;
	mov [L5+1],0
	mov [L5],0
	.dbline 24
;     if (WZC(state_timer) && state_timer_mode) state_timer--;
	mov A,[_state_timer]
	or A,[_state_timer+1]
	jz L8
	cmp [_state_timer_mode],0
	jz L8
	.dbline 24
	dec [_state_timer+1]
	sbb [_state_timer],0
L8:
	.dbline 25
;     if (interval_timer) interval_timer--;
	cmp [_interval_timer],0
	jz L11
	.dbline 25
	dec [_interval_timer]
L11:
	.dbline 26
L6:
	.dbline -2
	.dbline 27
;   }
; }
L4:
	pop A
	.dbline 0 ; func end
	reti
	.dbend
	.area data(ram, con, rel)
	.dbfile ./time.c
L14:
	.blkb 1
	.area idata
	.byte 7
	.area data(ram, con, rel)
	.dbfile ./time.c
	.area text(rom, con, rel)
	.dbfile ./time.c
	.dbfunc e set_state_timer _set_state_timer fV
	.dbsym s old_state L14 c
;          value -> X-5
_set_state_timer::
	.dbline -1
	push X
	mov X,SP
	.dbline 31
; 
; 
; void set_state_timer(WORD value)
; {
	.dbline 34
;   static BYTE old_state = POWER_ON;
;   
;   if (state != old_state)
	mov A,[_state]
	cmp A,[L14]
	jz L15
	.dbline 35
;   {
	.dbline 36
;     M8C_DisableGInt;
		and F, FEh

	.dbline 37
;     state_timer = value;
	mov A,[X-4]
	mov [_state_timer+1],A
	mov A,[X-5]
	mov [_state_timer],A
	.dbline 38
;     state_timer_mode = TRUE;
	mov [_state_timer_mode],1
	.dbline 39
;     M8C_EnableGInt;
		or  F, 01h

	.dbline 40
;   }
L15:
	.dbline 42
;   
;   old_state = state;  
	mov [L14],[_state]
	.dbline -2
	.dbline 43
; }
L13:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -5 i
	.dbend
	.dbfunc e check_state_timer _check_state_timer fc
;           cond -> X+0
_check_state_timer::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 47
; 
; 
; BOOL check_state_timer(void)
; {
	.dbline 50
;    BOOL cond;
; 
;    M8C_DisableGInt;
		and F, FEh

	.dbline 51
;    cond = WZC(state_timer);
	mov A,[_state_timer]
	or A,[_state_timer+1]
	mov [X+0],A
	.dbline 52
;    M8C_EnableGInt;
		or  F, 01h

	.dbline 54
;    
;    return !cond;
	cmp [X+0],0
	jnz L20
	mov [X+2],1
	mov [X+1],0
	xjmp L21
L20:
	mov [X+2],0
	mov [X+1],0
L21:
	mov A,[X+2]
	.dbline -2
L17:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l cond 0 c
	.dbend
	.dbfunc e control_state_timer _control_state_timer fV
;   timer_resume -> X-4
_control_state_timer::
	.dbline -1
	push X
	mov X,SP
	.dbline 58
; }
; 
; void control_state_timer(BYTE timer_resume)
; {
	.dbline 59
;   state_timer_mode =  timer_resume;
	mov A,[X-4]
	mov [_state_timer_mode],A
	.dbline -2
	.dbline 60
; }
L22:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l timer_resume -4 c
	.dbend
	.dbfunc e read_state_timer _read_state_timer fi
;           temp -> X+0
_read_state_timer::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 63
; 
; WORD read_state_timer(void)
; {
	.dbline 66
;    WORD temp;
;    
;    M8C_DisableGInt;
		and F, FEh

	.dbline 67
;    temp = state_timer;
	mov A,[_state_timer+1]
	mov [X+1],A
	mov A,[_state_timer]
	mov [X+0],A
	.dbline 68
;    M8C_EnableGInt;
		or  F, 01h

	.dbline 70
;    
;    return temp;
	mov A,[X+1]
	mov [__r1],A
	mov A,[X+0]
	mov [__r0],A
	.dbline -2
L23:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l temp 0 i
	.dbend
	.dbfunc e set_interval_timer _set_interval_timer fV
;          value -> X-4
_set_interval_timer::
	.dbline -1
	push X
	mov X,SP
	.dbline 74
; }
; 
; void set_interval_timer(BYTE value)
; {
	.dbline 75
;   interval_timer = value;
	mov A,[X-4]
	mov [_interval_timer],A
	.dbline -2
	.dbline 76
; }
L24:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l value -4 c
	.dbend
	.dbfunc e check_interval_timer _check_interval_timer fc
;           temp -> X+0
_check_interval_timer::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 79
; 
; BYTE check_interval_timer(void)
; {  
	.dbline 80
;    BYTE temp = interval_timer;
	mov A,[_interval_timer]
	mov [X+0],A
	.dbline 81
;    return !temp;
	cmp [X+0],0
	jnz L27
	mov [X+2],1
	mov [X+1],0
	xjmp L28
L27:
	mov [X+2],0
	mov [X+1],0
L28:
	mov A,[X+2]
	.dbline -2
L25:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l temp 0 c
	.dbend
