#ifndef __UTILS_H
#define __UTILS_H

#include <m8c.h>
#include <limits.h>

#define CHECKBIT(ADDRESS, BIT)      ( (ADDRESS) &   ( 1 << (BIT) ) )
#define SETBIT(ADDRESS, BIT)        ( (ADDRESS) |=  ( 1 << (BIT) ) )
#define CLEARBIT(ADDRESS, BIT)      ( (ADDRESS) &= ~( 1 << (BIT) ) )
#define BIT(bitNumber)              ( 1 << (bitNumber) )

#define ISRANGE(a, min, max) ((a >= min) && (a <= max))

void delayl(unsigned long cycles);
void delayi(unsigned int cycles);
void delayc(unsigned char cycles);
unsigned char find_max(unsigned char * data, unsigned char count);

BYTE copystrfn(const BYTE *source, BYTE *dest, BYTE max_len);


void test_leds(void);

#define MAX(A,B) {((A)>(B))?(A):(B)}

#define CHECKRANGE(value, min, max) {if ((value) < (min)) (value) = (min); \
									 if ((value) > (max)) (value) = (max);}	


#endif 
